{-# OPTIONS_GHC -Wno-missing-signatures #-}
{-# LANGUAGE RecordWildCards #-}

module Webpage(webpage) where
import Html
import Caster
import Data.Time
import Data.ByteString.Lazy

webpage :: Day -> [Caster] -> ByteString
webpage jpday casters =
     renderByteString $
     DOCTYPE # Html :>
     Webpage.head #
     Body :> (
      P :> ("Ages on " ++ (show jpday)) #
      table (Prelude.map tablerow casters) #
      dateinput #
      (P :> A :@ HrefA := "https://git.vern.cc/pta/caster_age_table" :> "git repo"))

head =
  Head :>
  (Meta :@ (CharsetA := "utf-8") #
   Title :> "WNI caster birthdays and ages" #
   Link :@ (RelA := "stylesheet" # HrefA := "style.css"))

sortOnDOB = A :@ HrefA := "https://pta.vern.cc/caster-age.cgi?sorton=dob" :> "生年月日"
sortOnCd = A :@ HrefA := "https://pta.vern.cc/caster-age.cgi?sorton=cd" :> "秒読み"
  
table tds =
   Table :>
   (Thead :>
    Tr :> (Td :> "名前" # Td :> sortOnDOB # Td :> "年" # Td :> "箇月" # Td :> "日" # Td :> sortOnCd) #
    Tbody :> tds)

tablerow Caster{..} =
  Tr :> (Td :> casterName # Td :> (show casterBday) # Td :> show (ageY casterAge) # Td :> show (ageM casterAge) # Td :> show (ageD casterAge) # Td :> show (ageCountdown casterAge))

dateinput =
  Form :@ (MethodA := "get" # ActionA := "caster-age.cgi") :> (Input :@ (TypeA := "date" # NameA := "date") # Input :@ TypeA := "submit")
